/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.hama.bsp.message;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hama.bsp.LyraRecoverMessage;
import org.apache.hama.ipc.HamaRPCProtocolVersion;

public interface LyraRecoverSender extends HamaRPCProtocolVersion{

  public void init(Configuration conf, int myId, int handler);
  
  public void setConf(Configuration conf);

  public Configuration getConf();
  
  public void close();
  
  public void transfer(String peerName, LyraRecoverMessage message) throws IOException;

  void clearTransferBuffer(String peerName) throws IOException;
  
  public long getProtocolVersion(String protocol, long clientVersion);

  
}
